
public class Code {
	private int n; // taile de l'alphabet
	private char alphabet[]; // tableau de symboles de l'alphabet
	private String motsCode[];//tableau de suites binaires, mots du code
	
	
	public Code(int k, char alph[], String mots[])//constructeur
	{
		this.n=k;
		this.alphabet=alph;
		this.motsCode=mots;
	}
	
	

	
	public String coderSymbole(char caract) 
	/* cette mthode recherche un caractre donn , caract, dans 
	 * l'alphabet  et renvoie son mot code ou null si le 
	 * caractre n'est pas dans l'alphabet 
	 */
	{
	   int i=0;
		while(alphabet[i]!=caract && i<n)
		{
			i++;
		}
		 if(i<n)
			{return motsCode[i];
			}
		 else return null;
		
	}
	
	public String decoderMot(String mot)
	/* cette mthode recherche un mot binaire donn, mot, dans le 
	 * tableau des mots de  code, caract,   et renvoie 
	 * le symbole de l'alphabet correspondant ou null si le mot
	 * n'est pas trouv
	 */
	{
		int i=0;
		while( i<n && !motsCode[i].equals(mot))
		{
			
			i++;
		}
		 if(i<n)
			{
			 return String.valueOf(alphabet[i]);
			}
		 else return null;
		
	}
	
	public double longMoy(double prob[])
	{
		double L=0;
		for(int i=0;i<this.n;i++){
			L=L+prob[i]*this.motsCode[i].length();
		}
		return L;
	}
	
	
	
	/*
	 * Mthodes  faire:
	 */
	public String coder(String message)
	{
		/*
		 * Cette mthode permet de coder  un message compos de
		 * symboles de l'alphabet. On parcourt le message caractre par caractre.
		 * Pour chaque caractre, on appelle la mthode
		 * "coderSymbole"  qui renvoie le mot du code correspondant.
		 * On cre la squence code en concatnant les mots de code 
		 * au fur et  mesure de la lecture du message
		 */
		 
		
	}
	
	 
	
	public void lectureArbre(String mot,ArbreCodage ar){
		/*
	 * mthode de lecture d'une table
	 *  de code  partir d'un arbre binaire
	 *  elle effectue un parcourt en profondeur de l'arbre 
	 *  et remplit la table de mots de code en fonction des caractres dcouverts sur les feuilles
	 *  la mthode suppose que la table de l'alphabet est dj connue 
	 */ 
		
		if (ar.estFeuille())
		{ // une feuille est atteinte
			String s=ar.getLettre(); // on rcupre la lettre associe 
		  int i=0;
		  // on recherche la position de cette lettre dans l'alphabet du code
		  while(!s.equals(String.valueOf(this.alphabet[i])) && i<n)
		{
			i++;
		}
		 if(i<n)
			{ // on inscrit le mot binaire qui reprsente le chemin  cette lettre depuis la racine
			 // dans la table des mots  la position correspondante  la lettre
			 this.motsCode[i]=mot;
			}
		
		}
		else{
			// si on se trouve sur un noeud interne
			this.lectureArbre(mot+"1",ar.getGauche()); // on va  gauche  et on ajoute 1 au mot-chemin
			this.lectureArbre(mot+"0",ar.getDroit()); // on va  droite et on ajoute 0 au mot-chemin
			
		}
	}

}


